//SSLContextFacade.java

/**
 * Author Michael Claudius, Roskilde Computer Science College
 * Version 1.0 2006.12.01
 * Copyright 2006 by Michael Claudius
 * All rights reserved
 */

package SSLPackage;

// Note: The keystore file is named myKeyStore
// Remember to use your own file.

import java.net.*;
import java.io.*;

import javax.net.ssl.*;
import java.security.*;


public class SSLContextFacade {
    
    KeyStore keystore=null;
    KeyManager [] keymanagers;
    TrustManager [] trustmanagers;
    SecureRandom securerandom;
    SSLContext sslcontext = null;
    char [] archPassword = "secret".toCharArray();
    
    
    /** Creates a new instance */
    public SSLContextFacade() {
    }
    
    
    public SSLContextFacade(String password) {
        archPassword = password.toCharArray();
    }
    
    public void initContext() {
        
        try {
            FileInputStream fileinputstream = new FileInputStream("C:/D Drive/Undervisning/Cods/Solutions/SSL/src/SSLPackage/myKeyStore");
            keystore = KeyStore.getInstance("JCEKS");
            
            keystore.load(fileinputstream, archPassword);
        } catch (IOException ioexception) {
            System.out.println("Cannot load keystore.  Password may be wrong." + ioexception);
            System.exit(-3);
            
        } catch (GeneralSecurityException gse) {
            System.out.println("Error." + gse);
            System.exit(-4);
        }
        
        try{
            // Create key manager.  The key manager holds this peer's
            // private key.
            KeyManagerFactory keymanagerfactory = KeyManagerFactory.getInstance("SunX509");
            keymanagerfactory.init(keystore, archPassword);
            keymanagers = keymanagerfactory.getKeyManagers();
            
            // Create trust manager.  The trust manager hold other peers'
            // certificates.
            TrustManagerFactory trustmanagerfactory = TrustManagerFactory.getInstance("SunX509");
            trustmanagerfactory.init(keystore);
            trustmanagers = trustmanagerfactory.getTrustManagers();
            
            // Create SSL context.
            sslcontext = SSLContext.getInstance("SSL");
            securerandom = SecureRandom.getInstance("SHA1PRNG");
            sslcontext.init(keymanagers, trustmanagers, securerandom);
            
        } catch(GeneralSecurityException gse) {
            System.out.println("Error." + gse);
            System.exit(-4);
        }
        
    }
    
    public SSLServerSocketFactory getServerSocketFactory() {
        initContext();
        return (SSLServerSocketFactory)sslcontext.getServerSocketFactory();
    }
    
    public SSLSocketFactory getSocketFactory() {
        initContext();
        return sslcontext.getSocketFactory();
    }
    
}
